#ifndef KTR_H_INCLUDED_
#define KTR_H_INCLUDED_

#include "kblib/kblib.h"
#include "tinyutf8.h"
#include "utf8.h"

namespace tr {

std::u32string expand_set(std::u32string_view set);

std::string filter(std::string whitelist, std::string_view input);
std::string translate(std::string_view set1, std::string set2, std::string_view input);

inline std::u32string widen(std::string_view str)
{
	std::u32string ret;
	utf8::utf8to32(str.begin(), str.end(), std::back_inserter(ret));
	return ret;
}

inline std::string narrow(std::u32string_view str)
{
	std::string ret;
	utf8::utf32to8(str.begin(), str.end(), std::back_inserter(ret));
	return ret;
}

inline bool match(std::string_view whitelist, std::string_view input)
{
	return widen(input).find_first_not_of(expand_set(widen(whitelist))) != std::u32string::npos;
}

#if 0
//Currently, only filter. match, and translate are needed by the program.

enum Mode : unsigned {
	def = 0,
	
	complement = 1,
	c = complement,
	C = complement,
	
	del = 2,
	d = del,
	
	squeeze = 4,
	s = squeeze,
	
	truncate = 8,
	t = truncate,
};

template <typename Char>
std::basic_string<Char> tr(Mode mode, std::basic_string_view<Char> set1, std::basic_string_view<Char> set2, std::basic_string_view<Char> input)
{
	if (mode == tr::squeeze) {
		
	} else if (mode & tr::complement) {
		
	} else if (mode & tr::del) {
		
	} else {
		
	}
}

template <Mode mode, typename Char>
std::basic_string<Char> tr(std::basic_string_view<Char> set1, std::basic_string_view<Char> set2, std::basic_string_view<Char> input)
{
	if constexpr (mode == tr::def) {
		return translate(set1, set2, input);
	} else if constexpr (mode == (tr::c | tr::d)) {
		return filter(set1, input);
	}
}
#endif

} // namespace tr

#endif //KTR_H_INCLUDED_